#ifndef VKAR_PHASE_RECPIXSUPARR_H
#define VKAR_PHASE_RECPIXSUPARR_H

#include <vector>
#include <valarray>
#include "RecPixArr.h"
#include "FrameSet.h"

/** A rectangular pixelized array with double values in windowed regions.
* The class contains rectangular non-overlapping subregions on a
* commensurate common pixel basis. Values in the interstitial regions between
* these windows are not stored. The main functionality is an efficient
* storage scheme for a big rectangular region (super-array) with internal
* stripe and sub-block geometry.
* The contents is equivalent to one mode or one phase screen.
* @author R. J. Mathar
* @since 2010-10-31
*/
template <class TYP> class RecPixSupArr {
public:
	/** The subwindows.
	*/
	std::vector<RecPixArr <TYP> > vals ;





	RecPixSupArr() ;


	template <class TYPV> void set(const TYPV *fval, const FrameSet & fs) ;

	TYP at(int x, int y, const FrameSet & fs) const ;

	std::valarray<TYP> toValarray(const FrameSet & fs) const ;
protected:

private:
} ;
#endif /* VKAR_PHASE_RECPIXSUPARR_H */
